# NOTE: Derived from blib/lib/Text/UPF.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package Text::UPF;

#line 139 "blib/lib/Text/UPF.pm (autosplit into blib/lib/auto/Text/UPF/Wants.al)"
## AutoLoaded Methods


## Wants ##########################################
## return a unique list of datafields required in 
## the given form letter
sub Wants {
	my ($self, %p) = @_;
	
	#try to open File, if it exists
	unless (exists ($p{Text})){
		if (exists ($p{Form})){
			unless ($p{Text} = $self->GetFormDB(Form => $p{Form})){
				$self->{errstr} = "failed to get form ($p{Form}) from database! $self->{errstr}";
				return (undef);
			}
		}elsif (exists ($p{File})){
			unless ($p{Text} = $self->GetFormFile(File => $p{File})){
				$self->{errstr} = "failed to open form file ($p{File}) $self->{errstr}";
				return (undef);
			}
		}else{
			$self->{errstr} = "Text, Form, or File is a required option for Text::UPF::Populate";
			return (undef);
		}
	}
	
	#local for easier regex syntax
	my ($tagin,$tagout) = ($self->{tagin},$self->{tagout});
	
	#go through and get all the pop tags
	my %wants = ();
	while ($p{Text} =~s/($tagin)(.+?)($tagout)//i){
		$wants{$2} ++;
	}
	
	my @return = keys(%wants);
	return (\@return);
	
}

# end of Text::UPF::Wants
1;
