# NOTE: Derived from blib/lib/Text/UPF.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package Text::UPF;

#line 300 "blib/lib/Text/UPF.pm (autosplit into blib/lib/auto/Text/UPF/ShowDiary.al)"
## ShowDiary ######################
##this "decodes" the format that diaries are passed in as
##the optional mode specifies "html" or "text". "text" inserts
##the text in <pre> tags. "html" makes a list-entry style output.
##default mode is "html"
sub ShowDiary {
     my ($self, %p) = @_;
    #the directive contains a hash!
     my %directive = ();
     my $str = '%directive = ( ';
     $str   .= $p{directive};
     $str   .= ')';
     eval ($str);
    #default mode
     if (! exists($directive{'Mode'})){ $directive{'Mode'} = "html"; }
    #make sure we have the data we need
     unless (exists($p{Data}->{$directive{'Data'}})){
         $self->{errstr} = "$directive{'Data'} does not exist in Data ... no diary to show";
         $out = "no diary to show";
         return($out);
     }
    #prefixes and stuff
     if ($directive{'Mode'} eq "html"){
         $out = "";
     }else {
         $out = "<pre>";
     }
    #do it
     foreach (@{$p{Data}->{$directive{'Data'}}}){
        #user / timestamp
         if ($directive{'Mode'} eq "html"){
             $out .= "<b>$_->{timestamp} - User: <font color=red>$_->{user}</font></b><hr noshade><p>\n";
             $out .= "<pre>$_->{'value'}</pre>\n";
             $out .= "<br><br></li>\n";
         }else{
             $out .= "[USER]: $_->{user}  /  [DATE]: $_->{timestamp}\n";
             my @temp = split ("\n",$_->{value});
             foreach $l (@temp){
                 $out .= "\t$l\n";
             }
         }
     }
    #suffixes and stuff
     if ($directive{'Mode'} eq "html"){
         $out .= "";
     }else {
         $out .= "</pre>";
     }
    #back out there
     return ($out);
}

# end of Text::UPF::ShowDiary
1;
